# coding: utf-8

"""
    Magneto API

    Magneto API is the RESTful API for the Rely.io platform.

    The version of the OpenAPI document: v0.0.1
    Contact: contact@rely.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from magneto_api_client.models.fetch_status import FetchStatus
from magneto_api_client.models.plugin_capability import PluginCapability
from magneto_api_client.models.plugin_legacy_file_to_check import PluginLegacyFileToCheck
from typing import Optional, Set
from typing_extensions import Self

class PluginLegacyRead(BaseModel):
    """
    PluginLegacyRead
    """ # noqa: E501
    name: StrictStr
    source_key: Optional[StrictStr] = Field(default=None, alias="sourceKey")
    status: Optional[StrictInt] = 1
    customer_managed: Optional[StrictBool] = Field(default=False, alias="customerManaged")
    assets_for_discovery: Optional[List[StrictStr]] = Field(default=None, alias="assetsForDiscovery")
    id: Annotated[str, Field(strict=True)]
    data_source: StrictStr = Field(alias="dataSource")
    fetch_status: FetchStatus = Field(alias="fetchStatus")
    capabilities: Optional[List[PluginCapability]] = None
    properties: Optional[Dict[str, Any]] = None
    files_to_check: Optional[List[PluginLegacyFileToCheck]] = Field(default=None, alias="filesToCheck")
    __properties: ClassVar[List[str]] = ["name", "sourceKey", "status", "customerManaged", "assetsForDiscovery", "id", "dataSource", "fetchStatus", "capabilities", "properties", "filesToCheck"]

    @field_validator('id')
    def id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^([a-z0-9_.-]+)$", value):
            raise ValueError(r"must validate the regular expression /^([a-z0-9_.-]+)$/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PluginLegacyRead from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of fetch_status
        if self.fetch_status:
            _dict['fetchStatus'] = self.fetch_status.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in files_to_check (list)
        _items = []
        if self.files_to_check:
            for _item_files_to_check in self.files_to_check:
                if _item_files_to_check:
                    _items.append(_item_files_to_check.to_dict())
            _dict['filesToCheck'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PluginLegacyRead from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "sourceKey": obj.get("sourceKey"),
            "status": obj.get("status") if obj.get("status") is not None else 1,
            "customerManaged": obj.get("customerManaged") if obj.get("customerManaged") is not None else False,
            "assetsForDiscovery": obj.get("assetsForDiscovery"),
            "id": obj.get("id"),
            "dataSource": obj.get("dataSource"),
            "fetchStatus": FetchStatus.from_dict(obj["fetchStatus"]) if obj.get("fetchStatus") is not None else None,
            "capabilities": obj.get("capabilities"),
            "properties": obj.get("properties"),
            "filesToCheck": [PluginLegacyFileToCheck.from_dict(_item) for _item in obj["filesToCheck"]] if obj.get("filesToCheck") is not None else None
        })
        return _obj


